variables:
  CI_REGISTRY: codeish/pact-gitlab
  CI_REGISTRY_USER: codeish
  CI_REGISTRY_IMAGE: codeish/gitlab-api
  ARTIFACT_NAME: gitlab-api-v$CI_PIPELINE_IID.jar
  CONTAINER_NAME: pact-gitlab
  BACKUP_CONTAINER_NAME: backup-gitlab-api-v$CI_PIPELINE_IID

stages:
- build
- build-image
- pact-provider-verification
- deploy

maven-build:
  image: maven:3-jdk-11
  stage: .pre
  script:
    - mvn clean install package
    - mv ./target/gitlab-api-0.0.5-SNAPSHOT.jar ./target/gitlab-api
    #- java -jar ./target/providerbuild &ARTIFACT_NAME
  artifacts:
    paths:
      - ./target/

build image:
  image: docker:latest
  stage: build-image
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD"
  script:
    - docker build -t "$CI_REGISTRY_IMAGE:$CI_PIPELINE_IID" .
    - docker push "$CI_REGISTRY_IMAGE:$CI_PIPELINE_IID"


pact-provider-verification:
  stage: pact-provider-verification
  image:
    name: pactfoundation/pact-cli:latest
    entrypoint: [""]
   
  script:
    - "pact verify 
      --consumer-version-tag=main 
      --provider=GitLabCatalogue 
      --provider-app-version=2
      --provider-version-tag=main
      --provider_base_url=http://app:8081
      --provider-states-setup-url=http://app:8081/getMembers/32568636 
      --pact-broker-base-url=https://ishcode.pactflow.io 
      --broker-token=CDM1ulK4zsh5DI3uJ_0vGQ
      --wait=10 
      --publish-verification-results"
      

deploy-job:
  stage: deploy
  script:
      - echo starting deployment
  when: manual
              

